/**************************************************************
 * RobotComm.h 
 *
 * Copyright (C) 2002 - Pacific Star Technologies Ltd 
 * All Rights Reserved. Unauthorized dissemination of this file
 * is strictly prohibited.
 *
 * Created: Jul 24, 2002 
 *************************************************************/
#ifndef ROBOTCOMM_H_
#define ROBOTCOMM_H_

#include "RobotDefs.h"
#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

HROBOT RCOpen(HINSTANCE inst);
void RCClose(HROBOT rbt);

// these are for grouping commands together before sending
HCGROUP RCNewCmdGroup(void);
void RCFreeCmdGroup(HCGROUP grp);
void RCClearCmdGroup(HCGROUP grp);
RCResult RCAddMove(HCGROUP grp, RCMoveDir dir, RCMoveSpeed sp);
RCResult RCAddMoveArm(HCGROUP grp, RCSide arm, RCDirection dir);
RCResult RCAddMoveHand(HCGROUP grp, RCSide hand, BOOL start);
RCResult RCAddMoveHead(HCGROUP grp, RCSide side, BOOL start);
RCResult RCAddTilt(HCGROUP grp, RCDirection dir);
RCResult RCAddArmLock(HCGROUP grp, BOOL on);
RCResult RCAddLight(HCGROUP grp);
RCResult RCAddVideoOn(HCGROUP grp, BOOL on);
RCResult RCAddSetOpMode(HCGROUP grp, RCOpMode mode);
RCResult RCAddSetVideoChannel(HCGROUP grp, RCChannel ch);
RCResult RCAddSetControlChannel(HCGROUP grp, RCChannel ch);
RCResult RCAddSetVolume(HCGROUP grp, RCVolume volume);
RCResult RCSendCmdGroup(HROBOT rbt, HCGROUP grp);

// these are for sending commands immediately
RCResult RCMove(HROBOT rbt, RCMoveDir dir, RCMoveSpeed sp);
RCResult RCMoveArm(HROBOT rbt, RCSide arm, RCDirection dir);
RCResult RCMoveHand(HROBOT rbt, RCSide hand, BOOL start);
RCResult RCMoveHead(HROBOT rbt, RCSide side, BOOL start);
RCResult RCTilt(HROBOT rbt, RCDirection dir);
RCResult RCArmLock(HROBOT rbt, BOOL on);
RCResult RCLight(HROBOT rbt);
RCResult RCSetOpMode(HROBOT rbt, RCOpMode mode);
RCResult RCVideoOn(HROBOT, BOOL on);
RCResult RCSetVideoChannel(HROBOT rbt, RCChannel ch);
RCResult RCSetControlChannel(HROBOT rbt, RCChannel ch);
RCResult RCSetVolume(HROBOT rbt, RCVolume vol);
RCResult RCGetStatus(HROBOT rbt, RCStatus *status);
RCResult RCPower(HROBOT rbt, BOOL on);

#ifdef __cplusplus
}
#endif // ifdef __cplusplus
#endif // ifndef ROBOTCOMM_H_
